var $4mxld$jsxpragmatic = require("jsx-pragmatic");
var $4mxld$zoid = require("zoid");

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
function $parcel$exportWildcard(dest, source) {
  Object.keys(source).forEach(function(key) {
    if (key === 'default' || key === '__esModule' || dest.hasOwnProperty(key)) {
      return;
    }

    Object.defineProperty(dest, key, {
      enumerable: true,
      get: function get() {
        return source[key];
      }
    });
  });

  return dest;
}
function $parcel$interopDefault(a) {
  return a && a.__esModule ? a.default : a;
}

$parcel$export(module.exports, "Notabene", () => $fef5d623a19b12b5$export$2e2bcd8739ae039);


var $48505191f6b4c91c$exports = {};

$parcel$export($48505191f6b4c91c$exports, "WidgetType", () => $48505191f6b4c91c$export$95cdd842edb044c5);
let $48505191f6b4c91c$export$95cdd842edb044c5;
(function($48505191f6b4c91c$export$95cdd842edb044c5) {
    $48505191f6b4c91c$export$95cdd842edb044c5["WITHDRAWAL"] = "WITHDRAWAL";
    $48505191f6b4c91c$export$95cdd842edb044c5["POST_DEPOSIT"] = "POST_DEPOSIT";
})($48505191f6b4c91c$export$95cdd842edb044c5 || ($48505191f6b4c91c$export$95cdd842edb044c5 = {}));


const $fd25ee12f453fb93$var$generalProps = {
    vaspDID: {
        type: 'string',
        required: true
    },
    transaction: {
        type: 'object',
        required: false
    },
    error: {
        type: 'object',
        required: false
    },
    onError: {
        type: 'function',
        required: true
    },
    storeTransaction: {
        type: 'function',
        required: true
    },
    theme: {
        type: 'object',
        required: false
    },
    dictionary: {
        type: 'object',
        required: false
    },
    transactionTypeAllowed: {
        type: 'string',
        required: false
    },
    nonCustodialDeclarationType: {
        type: 'string',
        required: false
    },
    beneficiaryDetails: {
        type: 'array',
        required: false
    },
    fieldsProps: {
        type: 'object',
        required: false
    },
    fallbacks: {
        type: 'array',
        required: false
    },
    optInFeatures: {
        type: 'array',
        required: false
    }
};
const $fd25ee12f453fb93$export$1aafbfc7f973e450 = {
    ...$fd25ee12f453fb93$var$generalProps,
    onRequireAdditionalInformation: {
        type: 'function',
        required: true
    },
    onValidStateChange: {
        type: 'function',
        required: true
    }
};
const $fd25ee12f453fb93$export$73ab9d0d47d71b0c = {
    ...$fd25ee12f453fb93$var$generalProps,
    close: {
        type: 'function'
    },
    popupOpen: {
        type: 'boolean',
        required: true
    },
    setPopupOpen: {
        type: 'function',
        required: true
    }
};


class $fef5d623a19b12b5$export$2e2bcd8739ae039 {
    constructor(config){
        this.config = config;
        this.config.nonCustodialDeclarationType = config.nonCustodialDeclarationType || 'SIGNATURE';
        this.config.transactionTypeAllowed = config.transactionTypeAllowed || 'ALL';
        this.widgetRendered = false;
        this.shouldBeDestroyed = false;
        this.popupRendered = false;
        this.config.fallbacks = this.config.fallbacks || [
            {
                flow: 'WALLET_NOT_SUPPORTED',
                action: 'DECLARATION'
            }, 
        ];
        this.config.counterpartyManualEntry = this.config.counterpartyManualEntry !== undefined ? this.config.counterpartyManualEntry : true;
    }
    /**
   * Renders a new widget
   * @param type - the type of widget to render
   */ async renderWidget(type = $48505191f6b4c91c$export$95cdd842edb044c5.WITHDRAWAL) {
        this._renderWidget(type);
    }
    async _renderWidget(type) {
        if (this.widgetRendered) {
            console.error('Notabene: Widget already rendered, please destroy it first');
            this.config.onError(new Error('Widget already rendered, please destroy it first'));
            return;
        }
        this.widget = await this.buildWidget();
        this.popup = await this.buildPopup();
        this.widget.updateProps({
            transaction: this.tx,
            type: type
        });
        this.popup.updateProps({
            transaction: this.tx,
            type: type
        });
        this.popup.hide();
        await this.widget.render(this.config.container);
        await this.renderPopup();
    }
    async renderPopup() {
        if (!this.popup) return;
        if (!this.popupRendered) {
            await this.popup.render(this.config.container);
            this.popupRendered = true;
        }
    }
    async destroyWidget() {
        if (!this.widgetRendered || !this.popupRendered) {
            this.shouldBeDestroyed = true;
            return;
        }
        await $4mxld$zoid.destroy();
        this.shouldBeDestroyed = false;
        this.widgetRendered = false;
        this.popupRendered = false;
    }
    setTransaction(tx) {
        this.tx = tx;
        if (this.widgetRendered) {
            this.widget.updateProps({
                transaction: tx
            });
            this.popup.updateProps({
                transaction: tx
            });
        }
    }
    cleanUpDestroyedComponents() {
        if (!this.shouldBeDestroyed) return;
        this.destroyWidget();
    }
    getWidgetUrl() {
        const url = new URL(this.config.widget);
        url.hash = `authToken=${this.config.authToken}`;
        return url.toString();
    }
    getAdditionalInfoUrl() {
        const url = new URL(this.config.widget);
        url.search = 'popup=true';
        url.hash = `authToken=${this.config.authToken}`;
        return url.toString();
    }
    handleError(err) {
        this.error = err;
        if (this.widget && this.popup) {
            this.widget.updateProps({
                error: err
            });
            this.popup.updateProps({
                error: err
            });
        }
        if (!err || !this.config.onError) return;
        this.config.onError(err);
    }
    buildWidget() {
        if (!this.config.authToken) {
            console.error('Notabene: authToken is required');
            return;
        }
        const builtWidget = ($parcel$interopDefault($4mxld$zoid)).create({
            tag: 'widget',
            url: this.getWidgetUrl(),
            dimensions: {
                width: '100%',
                height: '280px'
            },
            attributes: {
                iframe: {
                    allow: 'usb *;bluetooth *'
                }
            },
            props: $fd25ee12f453fb93$export$1aafbfc7f973e450
        })({
            vaspDID: this.config.vaspDID,
            transaction: {},
            theme: this.config.theme,
            dictionary: this.config.dictionary,
            transactionTypeAllowed: this.config.transactionTypeAllowed,
            nonCustodialDeclarationType: this.config.nonCustodialDeclarationType,
            beneficiaryDetails: this.config.beneficiaryDetails,
            fieldsProps: this.config.fieldsProps,
            fallbacks: this.config.fallbacks,
            optInFeatures: this.config.optInFeatures,
            counterpartyManualEntry: this.config.counterpartyManualEntry,
            onRequireAdditionalInformation: ()=>{
                this.popup.updateProps({
                    popupOpen: true
                });
                this.popup.show();
            },
            onValidStateChange: (isValid)=>{
                this.config.onValidStateChange(isValid);
            },
            error: this.error,
            onError: (err)=>{
                this.handleError(err);
                console.debug('Notabene: Error handler called');
            },
            storeTransaction: (tx)=>{
                this.setTransaction(tx);
            }
        });
        builtWidget.event.on(($parcel$interopDefault($4mxld$zoid)).EVENT.RENDERED, ()=>{
            this.widgetRendered = true;
            this.cleanUpDestroyedComponents();
        });
        return builtWidget;
    }
    buildPopup() {
        if (!this.config.authToken) {
            console.error('Notabene: authToken is required');
            return;
        }
        const builtPopup = ($parcel$interopDefault($4mxld$zoid)).create({
            tag: 'popup',
            url: this.getAdditionalInfoUrl(),
            children: ()=>{
                return {
                    Transaction: this.tx
                };
            },
            dimensions: {
                width: '100%',
                height: '100%'
            },
            attributes: {
                iframe: {
                    allow: 'usb *;bluetooth *'
                }
            },
            props: $fd25ee12f453fb93$export$73ab9d0d47d71b0c,
            containerTemplate: ({ uid: uid , doc: doc , frame: frame , prerenderFrame: prerenderFrame  })=>{
                return $4mxld$jsxpragmatic.node('div', {
                    id: uid,
                    class: 'nb-container'
                }, $4mxld$jsxpragmatic.node('style', null, `
            #${uid}.container {
                border: 5px solid red;
            }
            .nb-overlay {
              position: fixed;
              width: 100vw;
              height: 100vh;
              top: 0;
              left: 0;
              display: flex;
              align-items: center;
              justify-content: center;
              background-color: rgba(0,0,0,0.5);
            }
            .nb-popup {
              width: 100%;
              height: 100%;
            }
            .nb-preloader {
              display: none;
            }
          `), $4mxld$jsxpragmatic.node('div', {
                    class: 'nb-overlay'
                }, $4mxld$jsxpragmatic.node('node', {
                    el: frame,
                    class: 'nb-popup'
                }), $4mxld$jsxpragmatic.node('node', {
                    el: prerenderFrame,
                    class: 'nb-preloader'
                }))).render($4mxld$jsxpragmatic.dom({
                    doc: doc
                }));
            }
        })({
            vaspDID: this.config.vaspDID,
            transaction: this.tx,
            beneficiaryDetails: this.config.beneficiaryDetails,
            fieldsProps: this.config.fieldsProps,
            counterpartyManualEntry: this.config.counterpartyManualEntry,
            storeTransaction: (tx)=>{
                this.setTransaction(tx);
                console.debug('Notabene: Transaction stored');
            },
            close: ()=>{
                this.popup.close();
                console.debug('Notabene: Popup closing');
            },
            setPopupOpen: (isOpen)=>{
                this.popup.updateProps({
                    popupOpen: isOpen
                });
            },
            error: this.error,
            onError: (err)=>{
                this.handleError(err);
                console.debug('Notabene: Error handler called');
            },
            popupOpen: false,
            theme: this.config.theme,
            dictionary: this.config.dictionary,
            transactionTypeAllowed: this.config.transactionTypeAllowed,
            nonCustodialDeclarationType: this.config.nonCustodialDeclarationType,
            fallbacks: this.config.fallbacks,
            optInFeatures: this.config.optInFeatures
        });
        builtPopup.event.on(($parcel$interopDefault($4mxld$zoid)).EVENT.RENDERED, ()=>{
            this.popupRendered = true;
            this.cleanUpDestroyedComponents();
        });
        return builtPopup;
    }
}
if (window) window.Notabene = $fef5d623a19b12b5$export$2e2bcd8739ae039;



$parcel$exportWildcard(module.exports, $48505191f6b4c91c$exports);


